#![feature(bufread_skip_until)]
mod tokenizer;
mod reader;

use std::io::{BufRead, BufReader, Read};

pub struct Attribute<'a> {
    pub name: &'a str,
    pub value: &'a str,
}

//impl<'a> Attribute<'a> {
//    pub fn new(&[u8]) -> Self {
//        Self {
//
//        }
//    }
//}

pub struct Element<'a> {
    pub tag: &'a str,
    attributes: Vec<Attribute<'a>>,
}

pub enum Node<'a> {
    Text(&'a [u8]),
    Tag(&'a Element<'a>),
    EndTag(&'a Element<'a>),
}

pub struct Charon<R> {
    reader: BufReader<R>,
}

impl<R> Charon<R> {
    pub fn new(reader: BufReader<R>) -> Self {
        Self { reader }
    }
}

impl<R: Read> Charon<R> {}

#[cfg(test)]
mod tests {
    #[test]
    fn reader() {
    }
}

